



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>HDU 4424 Conquer a New Region 最大生成树</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">HDU 4424 Conquer a New Region 最大生成树</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 20:33:42 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<p>给你一颗树 每条边有一个权&#20540; 选择一个点为中心 定义S&#20540;为中心到其它n-1个点的路径上的最小边权 求全部点S&#20540;的和</p>
<p>从大到小排序 每次合并2棵树 设为A集合 B集合 设A集合的最大S&#20540;的和为sumA B集合为sumB</p>
<p>中心在A或者B如今增加A-B这条边使得2个集合连通 由于A-B这条边的权&#20540;小于等于AB集合里面边的权&#20540; 所以假设合并之后中心在A 那么sumA = sumA&#043;B集合的点数*A-B这条边的权&#20540;&nbsp;sumB = sumB&#043;A集合的点数*A-B这条边的权&#20540; 2者取大</p>
<pre class="prettyprint linenums">#include &lt;cstdio&gt;<br />
#include &lt;cstring&gt;<br />
#include &lt;algorithm&gt;<br />
#include &lt;queue&gt;<br />
#include &lt;cmath&gt;<br />
using namespace std;<br />
const int maxn = 200010;<br />
int n;<br />
int f[maxn], rank[maxn];<br />
__int64 sum[maxn];

struct edge<br />
{<br />
	int u, v, w;<br />
}e[maxn];<br />
int find(int x)<br />
{<br />
	if(x != f[x])<br />
		return f[x] = find(f[x]);<br />
	return f[x];<br />
}<br />
bool cmp(edge a, edge b)<br />
{<br />
	return a.w &gt; b.w;<br />
}<br />
int main()<br />
{<br />
	while(scanf(&quot;%d&quot;, &amp;n) != EOF)<br />
	{<br />
		for(int i = 0; i &lt; n-1; i++)<br />
			scanf(&quot;%d %d %d&quot;, &amp;e[i].u, &amp;e[i].v, &amp;e[i].w);<br />
		sort(e, e+n-1, cmp);<br />
		for(int i = 0; i &lt;= n; i++)<br />
			f[i] = i, sum[i] = 0, rank[i] = 1;<br />
		for(int i = 0; i &lt; n-1; i++)<br />
		{<br />
			int x = find(e[i].u);<br />
			int y = find(e[i].v);<br />
			if(x != y)<br />
			{<br />
				if(sum[x]+(__int64)e[i].w*rank[y] &gt; sum[y]+(__int64)e[i].w*rank[x])<br />
				{<br />
					f[y] = x;<br />
					sum[x] = sum[x]+(__int64)e[i].w*rank[y];<br />
					rank[x] += rank[y];<br />
				}<br />
				else<br />
				{<br />
					f[x] = y;<br />
					sum[y] = sum[y]+(__int64)e[i].w*rank[x];<br />
					rank[y] += rank[x];<br />
				}<br />
			}<br />
		}<br />
		int x = find(1);<br />
		printf(&quot;%I64d\n&quot;, sum[x]);<br />
	}<br />
	return 0;<br />
}</pre>

</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9jzwne8.html">LINUX 编译安装 PHP 环境</a>
		</li>
						<li><a href="https://www.batexi.com/a/495zezv9.html">今天心情好，给各位免费呈上200兆SVN代码服务器一枚，不谢！</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql73ke9.html">什么是jsonp</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x3mxz8.html">解决VirtualBox 上的XP 蓝屏，自动重复启动</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn15j1j8.html">TIDB ---NEW SQL</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd22kk8.html">移动端远程关闭PC端实现（一）需求设计</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn17d5x8.html">printf输出函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pddk179.html">char与unsigned char 差别</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zoyve9.html">对中级 Linux 用户有用的 20 个命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z75we9.html">报错：error C2229&colon; class &amp;&num;39&semi; &amp;&num;39&semi; has an illegal zero-sized array 引发的思考</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo65odq.html">jQuery中下拉select、复选checkbox、单选radio的操作代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z5dw59.html">Twisted 延迟调用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyk44e9.html">左偏树&lpar;BZOJ4003&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk7e3v8.html">docker镜像保存及导出（save，export）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj2vn59.html">Luogu 1071 - 潜伏者 - &lbrack;字符串&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ody7x8.html">Jmeter对SQL Server进行压力测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2m7my9.html">有登陆认证的情况下如何使用Wisdom RESTClient&quest;</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1l24e9.html">PowerShell 批量签入SharePoint Document Library中的文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/93pvg2r8.html">cprogram作业</a>
		</li>
						<li><a href="https://www.batexi.com/a/953dr708.html">2018&period;10&period;18 NOIP训练 ZUA球困难综合征（线段树）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q4zgk7e9.html">perl学习&lpar;1&rpar; 入门</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zog36vq.html">FastStone Capture&lpar;FSCapture&rpar; 注册码 &lowbar;图形图像&lowbar;软件教程&lowbar;脚本之家</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzjvng8.html">Codeforces 41D Pawn 简单dp</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kp0r069.html">linux 内核头文件 linux kernel header</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m7lkj8.html">树莓派变成一个Web服务器： nginx &plus; php &plus; sqlite</a>
			</li>
						<li><a href="https://www.batexi.com/a/8memv40q.html">Krita 3&period;0 发布，KOffice 的图像处理器（刺激一下自己的神经）</a>
			</li>
						<li><a href="https://www.batexi.com/a/950r1368.html">九度OnlineJudge之1022：游船出租</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1km6d49.html">JS多维数组转一维</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzj4448.html">SQL SERVER 2008R2sp1配置Database Mail &ndash;用SQL 数据库发邮件</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mem5noq.html">scanf&lpar;&rpar;常犯错误</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
